<!DOCTYPE html>
<html lang="en">
<head>
    <title>YSDA DB Course. Lecture 5.</title>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="shower/themes/yandex/styles/screen-16x9.css">

    <style type="text/css">
        code { display: block; white-space: pre; background-color: #EEE; }
        p.cloud { text-align: center; line-height: 1.5; }
        p.cloud span { font-size: 13pt; color: gray; padding: 0 20px 0 20px; white-space: nowrap; }
   </style>
</head>
<body class="shower list">
    <header class="caption">
        <h1>YSDA Databases 2023</h1>
    </header>

    <section class="slide" id="cover">
        <h1 style="margin-top: 150px;">Lecture 5. Indexes. Hash Table.</h1>
    </section>

    <section class="slide">
        <h2>Plan</h2>

        <p>1. Table indexes.</p>
        <p>2. Hash Table Overview.</p>
        <p>3. Hash Function.</p>
        <p>4. Static Hashing Scheme</p>
        <p>5. Static Hash Tables Overview</p>
        <p>6. Dynamic Hashing Scheme.</p>
    </section>


    <section class="slide">
        <h1>Table Indexes</h1>

        <p>A table index is a copy of a subset of table attributes that are organized and/or sorted for efficient
            access using part of the attributes on which the index is built.</p>
        <p>The DBMS provides logical synchronization of table and index contents.</p>
    </section>

    <section class="slide">
        <h1>Table Indexes</h1>

        <p>The job of a DBMS is to figure out which indexes are best to use to execute each query.</p>
        <p>There is a trade-off when choosing indexes for each database.</p>
        <p>1. Overhead for storing index data.</p>
        <p>2. Overhead of maintaining synchronization between table data and indexes.</p>
    </section>

    <section class="slide">
        <h1>Data Structures</h1>

        <p>Data structures in databases can be used to store:</p>

        <p>1. Internal metadata.</p>
        <p>2. Main table data.</p>
        <p>3. Temporary data structures (Join, External sort, Aggregation).</p>
        <p>4. Indexes data.</p>
    </section>

    <section class="slide">
        <h1>Data Structures</h1>

        <p>Hash Table</p>
        <p>B-Tree (B+-Tree)</p>
        <p>Tries</p>
    </section>

    <section class="slide">
        <h1>Data Structures</h1>

        <p><b>Data organization</b></p>
        <p>How we store the data structure in memory/pages and what information needs to be stored to support efficient access.</p>

        <p><b>Concurrency control</b></p>
        <p>How to allow multiple threads to access a data structure simultaneously without causing problems.</p>
    </section>

    <section class="slide">
        <h1>Hash Table Overview</h1>

        <p>A hash table implements an unordered associative array that maps keys to values.</p>
        <p>Uses a hash function to calculate the slot in the array in which the desired value can be found.</p>
    </section>

    <section class="slide">
        <h2>Hash Table Overview</h2>

        <p>Basic methods
            <ul>
                <li>Lookup O(1) average</li>
                <li>Insert O(1) average</li>
                <li>Erase O(1) average (Not very important for many scenarios)</li>
            </ul>
        </p>
    </section>

    <section class="slide">
        <h2>Hash Table Overview</h2>

        <img style="text-align: center; height:60%; margin-left: 150px;" src="pictures/hash_table_overview_1.png"/>
    </section>

    <section class="slide">
        <h2>Hash Table Overview</h2>

        <p>1. Hash Functions.</p>
        <p>2. Static Hashing Scheme.</p>
        <p>3. Dynamic Hashing Schemes.</p>
    </section>

    <section class="slide">
        <h2>Hash Functions</h2>

        <p>The hash function accepts any key as input. It then returns an integer representation of that key.</p>
        <p>The output of the function is deterministic (that is, the same key should always generate the same hash output).</p>
        <p>We are primarily interested in the speed of the hash function and its distribution.</p>
    </section>

    <section class="slide">
        <h2>Hash Functions</h2>

        <p>1. Do not use the identity function for integer types.</p>
        <p>2. Do not use hash functions for strings (CityHash) for integer types.</p>
        <p>3. Don't use cryptographic hash functions unless you're under attack. For example, SipHash calculation is ~980 MB/s. CityHash ~9 GB/s.</p>
        <p>4. Don't use legacy hash functions. FNV1a.</p>

        <p><a href="https://ticki.github.io/blog/designing-a-good-non-cryptographic-hash-function/">https://ticki.github.io/blog/designing-a-good-non-cryptographic-hash-function/</a></p>
    </section>

    <section class="slide">
        <h2>Hash Functions</h2>

        <p>CRC-64 (1975) - used in networks to detect errors.</p>
        <p>MurmurHash (2008) - designed as a general-purpose fast hash function.</p>
        <p>Google CityHash (2011) - acceleration of work with short keys (64 bytes).</p>
        <p>Facebook XXHash (2012) - from the creator of zstd compression.</p>
        <p>Google FarmHash (2014) is a newer version of CityHash with an improved collision rate.</p>

        <p><a href="https://github.com/rurban/smhasher">https://github.com/rurban/smhasher</a></p>
    </section>

    <section class="slide">
        <h2>Static Hashing schemes</h2>

        <p>A static hashing scheme is a scheme in which the size of the hash table is fixed.</p>
        <p>This means that if the DBMS runs out of space to store elements in its hash table, it must rebuild it from scratch with a larger table.</p>
        <p>This is also necessary to reduce the number of collisions.</p>
        <p>Most hash-tables implementation work well only with fill factor near 0.5.</p>
        <p>There are also implementation that work well with fill factor 0.875.</p>
    </section>

    <section class="slide">
        <h2>Hash Table</h2>

        <p>1. Hash function.</p>
        <p>2. Method for resolving collisions.</p>
        <p>3. Resize.</p>
        <p>4. Method of placing cells in memory.</p>
    </section>

    <section class="slide">
        <h2>Hash Table Performance</h2>

        <p>There are two different scenarios:</p>
        <p>When hash table fits in CPU caches. Performance of hash table operations depends on arithmetic operations like hash function calculation,
            computing slot location, elements comparisons, and other operations that are required for specific hash table memory layout.</p>
        <p>When hash table does not fit in CPU caches. For such a scenario, number of random memory accesses per operation is the most important
            factor for hash table performance.</p>
        <p>In practice memory access latency is around 100ns or even more, if memory is inside another NUMA node.</p>
    </section>

    <section class="slide">
        <h2>Hash Table Performance</h2>

        <p>Additionally, for the aggregation scenario, you need to consider not only lookup/insert latency but also memory size of hash table.
            If during aggregation hash table does not fit in RAM memory, the aggregation algorithm should switch implementation from in-memory
            aggregation to external memory aggregation, but this will work significantly slower.</p>
    </section>

    <section class="slide">
        <h2>Hash Table Performance</h2>

        <p>The trade-off between hash table operations (lookup/insert/delete) latency and memory size is really complex.</p>
        <p>For example, linear probing open addressing hash tables can work well only with a fill factor that is near 0.5, and with two resize factor,
            in the worst case, memory overhead for such will be 4x. But there are also hash table implementations that can work well with fill factor
            like 0.875 or even higher, but in practice, they will provide slower operations (lookup/insert/delete) latency.</p>
    </section>

    <section class="slide">
        <h2>Collision resolution</h2>

        <img style="height:75%; margin-left: 150px; margin-top: -50px;" src="pictures/hash_table_collision.png"/>
    </section>

    <section class="slide">
        <h2>Collision resolution</h2>

        <p>1. Chaining method.</p>
        <p>2. Open Addressing</p>
        <p>3. Good in theory (Cuckoo hashing, Hopscotch hashing, 2-choice hashing). Usually either difficult to implement,
            or slow due to additional memory fetches.</p>
    </section>

    <section class="slide">
        <h2>Chaining</h2>

        <img style="height:75%; margin-left: 150px; margin-top: -50px;" src="pictures/hash_table_collision_chaining.png"/>
    </section>

    <section class="slide">
        <h2>Chaining</h2>

        <p>Example: std::unordered_map</p>

        <p>1. Stability of pointers to key and value.</p>
        <p>2. Ability to store large objects, non-movable objects.</p>
        <p>3. Works well with poor hash function, high load factor.</p>
        <p>4. It slows down a lot. Loads the allocator (even just calling a function is expensive for the hot path).</p>
    </section>

    <section class="slide">
        <h2>Chaining</h2>

        <img style="height:75%; margin-left: 125px; margin-top: -50px;" src="pictures/hash_table_collision_open_addressing.png"/>
    </section>

    <section class="slide">
        <h2>Open Addressing</h2>

        <p>Linear probing. Example ClickHouse HashMap.</p>
        <p>Quadratic probing. Example: Google DenseHashMap.</p>

        <p>1. Good cache locality.</p>
        <p>2. You need to choose your hash function carefully.</p>
        <p>3. Large objects cannot be stored. We serialize into the arena and store pointers to them.</p>
    </section>

    <section class="slide">
        <h2>Resize</h2>

        <p>1. By powers of two. Fast modulo division.</p>
        <code style="display: block; white-space: pre; font-size: 19px;">size_t place = hash & (size - 1)</code>
        <br>
        <p>2. The size of a prime number is close to a power of two. Slow division even with constant switch, libdivide, fastrange.</p>
        <p>3. Fast alternative to module reduction.</p>

        <p><a href="https://lemire.me/blog/2016/06/27/a-fast-alternative-to-the-modulo-reduction/">A fast alternative to the modulo reduction</a></p>
    </section>

    <section class="slide">
        <h2>Load factor</h2>

        <p>0.5 is a good option for linear samples with a step of 1.</p>
        <p>ClickHouse HashMap, Google DenseHashMap uses 0.5.</p>
        <p>Abseil HashMap uses 0.875.</p>
    </section>

    <section class="slide">
        <h2>Hash Table Layout</h2>

        <img style="height:75%; margin-left: 125px; margin-top: -50px;" src="pictures/hash_table_layout.png"/>
    </section>

    <section class="slide">
        <h2>Hash Table Layout</h2>

        <p>Ask the client to select the keys for empty (sentinel) key and deleted (tombstone) key.</p>
        <img style="margin-left: 175px; height:60%" src="pictures/hash_table_layout_sentinels.png"/>
    </section>

    <section class="slide">
        <h2>Hash Table Layout</h2>

        <p>Handle the empty value separately and do not store it in the hash table.</p>
        <img style="margin-left: 175px; height:55%" src="pictures/hash_table_layout_null_special.png"/>
    </section>

    <section class="slide">
        <h2>Hash Table Layout</h2>

        <p>Compressed storage of metadata and data.</p>
        <img style="margin-left: 160px; height:60%" src="pictures/hash_table_metadata.png"/>
    </section>

    <section class="slide">
        <h2>Dynamic hashing schemes</h2>

        <p>Previous hash tables require the DBMS to know the number of elements it wants to put in the hash table.</p>
        <p>Otherwise, the hash table will be expanded periodically.</p>
        <p>Dynamic hash tables change their size on demand.</p>
    </section>

    <section class="slide">
        <h2>Dynamic hashing schemes</h2>

        <p>Chained hashing</p>
        <p>Extendible hashing</p>
        <p>Linear hashing</p>
    </section>

    <section class="slide">
        <h2>Chained hashing</h2>

        <img style="height:75%; margin-left: 125px; margin-top: -50px;" src="pictures/hash_table_layout.png"/>
    </section>

    <section class="slide">
        <h2>Extendible hashing</h2>

        <p>Extendible hashing is a type of hash system which treats a hash as a bit string and uses a trie for bucket lookup. </p>
        <p>Because of the hierarchical nature of the system, re-hashing is an incremental operation (done one bucket at a time, as needed).</p>
        <p>This means that time-sensitive applications are less affected by table growth than by standard full-table rehashes.</p>

        <p><a href="https://en.wikipedia.org/wiki/Extendible_hashing">https://en.wikipedia.org/wiki/Extendible_hashing</a></p>
    </section>

    <section class="slide">
        <h2>Linear hashing</h2>

        <p>The hash table has a split pointer that tracks the next bucket to split (starts from 0 bucket).</p>
        <p>When bucket in hash table overflows, split the bucket at the split pointer location.</p>
        <p>Use multiple hashes to find the right bucket for a given key, based on current split pointer location.</p>

        <p><a href="https://en.wikipedia.org/wiki/Linear_hashing">https://en.wikipedia.org/wiki/Linear_hashing</a></p>
    </section>

    <section class="slide">
        <h1>Index Usage</h1>

        <p>1. Implicit Indexes.</p>
        <p>2. Partial Indexes.</p>
        <p>3. Covering Indexes.</p>
        <p>4. Function/Expression Indexes.</p>
    </section>

    <section class="slide">
        <h1>Implicit Indexes</h1>

        <p>Most DBMSs automatically create an index for integrity purposes, but not for foreign keys.</p>

        <p>1. PRIMARY KEY</p>
        <p>2. UNIQUE CONSTRAINT</p>
    </section>

    <section class="slide">
        <h1>Partial Indexes</h1>

        <p>Create an index on a subset of the data from the table. This potentially reduces the size of the index and the amount of overhead required to maintain it.</p>
        <p>One common use case is to create separate indexes on date ranges.</p>
        <p>Create a separate index for month, year.</p>

        <code>CREATE INDEX idx_test_table ON test_table (value)
WHERE id > 25;</code>
    </section>

    <section class="slide">
        <h1>Covering Indexes</h1>

        <p>If all the fields needed to process the query are available in the index, then the DBMS does not need to retrieve the tuple.</p>
        <p>This reduces the load on the DBMS pool buffer.</p>

        <code>CREATE INDEX idx_test_table ON test_table (id, value)</code>
        <br>
        <code>SELECT value FROM test_table WHERE id > 5</code>
    </section>

    <section class="slide">
        <h1>Covering Indexes</h1>

        <p>The index stores additional columns to support index-only queries.</p>
        <p>These additional columns are stored only in leaf nodes and are not part of the search key.</p>

        <code>CREATE INDEX idx_test_table ON test_table (id, value)
INCLUDE (value2)</code>
        <br>
        <code>SELECT value2 FROM test_table
WHERE id > 5 AND value > 20</code>
    </section>

    <section class="slide">
        <h1>Function/Expression Indexes</h1>

        <p>Uses the result of a function or expression as a key.</p>
        <p>The job of the DBMS is to recognize which queries can use this index.</p>

        <code>CREATE INDEX idx_test_table
ON test_table (LENGTH(value))</code>
        <br>
        <code>SELECT id FROM test_table WHERE LENGTH(value) > 5</code>
    </section>

    <section class="slide">
        <h1>Conclusion</h1>

        <p>Fast data structures supporting O(1) search, which are used in all internal components of the DBMS.</p>
        <p>Trade-off between speed, memory consumption, flexibility.</p>
        <p>Indexes are used in databases to improve search operations performance.</p>
    </section>

    <section class="slide">
        <h1>Questions ?</h1>
    </section>

    <div class="progress"></div>
    <script src="shower/shower.min.js"></script>

    <!--Video plugin-->
    <link rel="stylesheet" href="shower/shower-video.css">
    <script src="shower/shower-video.js"></script>
    <!--/Video plugin-->
</body>
</html>
